<script>
import { chartMixin } from '@/mixins/chart'

export default {
  mixins: [chartMixin],
  props: {
    rows: {
      type: Array,
      required: true,
    },
  },
  data() {
    return {
      totalCount: 0,
      activeCount: 0,
      removedCount: 0,
      brokenCount: 0,
      metricsCharts: [
        'statusBarChart',
        'milestoneBarChart',
        'tierBarChart',
        'categoryPieChart',
        'sourcePieChart',
        'productCategoriesChart',
      ],
      statusBarChart: null,
      milestoneBarChart: null,
      tierBarChart: null,
      categoryPieChart: null,
      sourcePieChart: null,
      productCategoriesChart: null,
      resizeHandler: null,
    }
  },
  watch: {
    rows: {
      handler(newRows) {
        if (newRows.length > 0) {
          this.initializeCharts(this.metricsCharts, '/')
          this.resizeHandler = () => this.resizeCharts(this.metricsCharts)
          window.addEventListener('resize', this.resizeHandler)
        }
      },
      immediate: false,
    },
  },
  mounted() {
    if (this.rows?.length > 0) {
      this.initializeCharts(this.metricsCharts, '/')
      this.resizeHandler = () => this.resizeCharts(this.metricsCharts)
      window.addEventListener('resize', this.resizeHandler)
    }
  },
  beforeDestroy() {
    if (this.resizeHandler) {
      window.removeEventListener('resize', this.resizeHandler)
    }
    this.disposeCharts(this.metricsCharts)
  },
  methods: {
    updateSummary() {
      const filteredData = this.rows

      this.totalCount = filteredData.length
      this.activeCount = filteredData.filter(
        (row) => row.status === 'active',
      ).length
      this.removedCount = filteredData.filter(
        (row) => row.status === 'removed',
      ).length
      this.brokenCount = filteredData.filter(
        (row) => row.status === 'broken',
      ).length
    },
    updateCharts() {
      const categoryData = this.getCategoryData()
      const sourceData = this.getSourceData()

      this.statusBarChart?.setOption({
        tooltip: {
          trigger: 'axis',
          axisPointer: { type: 'shadow' },
          formatter: '{b}: {c}',
        },
        xAxis: {
          type: 'value',
          name: 'Count',
        },
        yAxis: {
          type: 'category',
          data: ['active', 'removed', 'broken'],
        },
        series: [
          {
            name: 'status',
            type: 'bar',
            data: [this.activeCount, this.removedCount, this.brokenCount],
            itemStyle: {
              color: function (params) {
                const colorList = ['#28a745', '#dc3545', '#ffc107']
                return colorList[params.dataIndex]
              },
            },
          },
        ],
      })

      this.updateMileStoneChart()
      this.updateTierChart()
      this.updateProductCategoriesChart()

      this.categoryPieChart?.setOption({
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)',
        },
        series: [
          {
            name: 'category',
            type: 'pie',
            radius: '55%',
            center: ['50%', '50%'],
            data: categoryData,
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
            itemStyle: {
              color: function (params) {
                const colorList = ['#61a0a8', '#d48265', '#91c7ae', '#c23531']
                return colorList[params.dataIndex % colorList.length]
              },
            },
          },
        ],
      })

      this.sourcePieChart?.setOption({
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)',
        },
        series: [
          {
            name: 'sources',
            type: 'pie',
            radius: '55%',
            center: ['50%', '50%'],
            data: sourceData,
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
            itemStyle: {
              color: function (params) {
                const colorList = [
                  '#e6194b',
                  '#3cb44b',
                  '#ffe119',
                  '#0082c8',
                  '#f58231',
                  '#911eb4',
                ]
                return colorList[params.dataIndex % colorList.length]
              },
            },
          },
        ],
      })
    },
  },
}
</script>

<template>
  <div>
    <div class="flex-container side-by-side-charts">
      <div class="flex-item">
        <h2>Status Metrics Distribution</h2>
        <div ref="statusBarChart" class="chart-container"></div>
      </div>

      <div class="flex-item">
        <h2>Milestone Distribution</h2>
        <div ref="milestoneBarChart" class="chart-container"></div>
      </div>
    </div>

    <div class="flex-container side-by-side-charts">
      <div class="flex-item">
        <h2>Tier Distribution</h2>
        <div ref="tierBarChart" class="chart-container"></div>
      </div>

      <div class="flex-item">
        <h2>Source Breakdown</h2>
        <div ref="sourcePieChart" class="chart-container"></div>
      </div>
    </div>

    <div class="flex-container side-by-side-charts">
      <div class="flex-item">
        <h2>Category Breakdown</h2>
        <div ref="categoryPieChart" class="chart-container"></div>
      </div>

      <div class="flex-item">
        <h2>Product Category Distribution</h2>
        <div ref="productCategoriesChart" class="chart-container"></div>
      </div>
    </div>
  </div>
</template>

<style scoped src="../assets/styles/charts.css"></style>
